bVerbose = false --debugging info
bLoaded = false --don't do anything until we are fully loaded, including savedvariables

--use new Default tables to deal with upgrades
_G.DefaultChannel = {"Guild","Party","Whisper","Say","Yell","Emote","RealID"}
_G.DefaultSound = {Guild="Guild-Yo.ogg",Party="Party-Hey.ogg",Whisper="TellMessage",Say="Say-Blah.ogg",Yell="Yell-Blarg.ogg",Emote="Emote-Rowl.ogg",RealID="Whisper-Psst.ogg"} --default sounds
_G.DefaultState = {Guild="2",Party="2",Whisper="1",Say="2",Yell="2",Emote="2",RealID="2"} --default off,internal,external

--these are the saved vars
_G.ChatChannel = {}
_G.ChatSound = {}
_G.ChatState = {}


--these are the slash commands
SLASH_BRIGAND_CHATTERBOX1 = '/bcb';
SlashCmdList["BRIGAND_CHATTERBOX"] = function( msg, editbox )
	--InterfaceOptionsFrame_OpenToCategory(Brigand_Chatterbox_Frame)
	
	if (bVerbose) then
		ChatFrame1:AddMessage( "Brigand_Chatterbox received:'" .. msg .. "'" )
	end
	
	local channel, space1, onoff, space2, sound = msg:match("(%a+)(%s*)(%d?)(%s*)([%a%p]*)")--("(%a+)(%s*)(%d?)(%s*)(%a*)")--("%w+")--("(%w+)(%s*)")--("^(%S*)%s*(.-)$")--
	
	if (bVerbose) then
		ChatFrame1:AddMessage( "Brigand_Chatterbox parsed:" )
		if (channel ~= nil) then
			ChatFrame1:AddMessage( "'" .. channel .. "'" )
		end
		if (space1 ~= nil) then
			ChatFrame1:AddMessage( "'" .. space1 .. "'" )
		end
		if (onoff ~= nil) then
			ChatFrame1:AddMessage( "'" .. onoff .. "'" )
		end
		if (space2 ~= nil) then
			ChatFrame1:AddMessage( "'" .. space2 .. "'" )
		end
		if (sound ~= nil) then
			ChatFrame1:AddMessage( "'" .. sound .. "'" )
		end
	end --bVerbose
	
	--report all channels
	local reportall = false
	if (channel == nil) then
		reportall = true
	elseif( channel:len() == 0) then
		reportall = true
	end
	
	if( reportall ) then
		ChatFrame1:AddMessage("Brigand_Chatterbox report all:")
		--InterfaceOptionsFrame_OpenToCategory(Brigand_Chatterbox_Options)
		for i = 1, #_G.ChatChannel do
			ChatFrame1:AddMessage( _G.ChatChannel[i] .. " " .. _G.ChatState[_G.ChatChannel[i]] .. " " .. _G.ChatSound[_G.ChatChannel[i]] )
		end
	else
		channel = channel:upper() --case insensitive
	end --reportall

	--report named channel
	local reportone = false
	if (onoff == nil) then
		reportone = true
	elseif (onoff:len() == 0) then
		reportone = true
	end
	
	if (reportone and not reportall ) then
		if (channel:upper() == "HELP") then
			ChatFrame1:AddMessage("Brigand_Chatterbox help:")

			ChatFrame1:AddMessage("'/bcb' reports current settings for all channels")
			
			ChatFrame1:AddMessage("'/bcb channel' reports current settings for one channel")
			local channellist = _G.ChatChannel[1]
			for i = 2, #_G.ChatChannel do
				channellist = channellist .. ", " .. _G.ChatChannel[i]
			end
			ChatFrame1:AddMessage("               valid channels are: " .. channellist)--tostring(_G.ChatChannel)
			
			ChatFrame1:AddMessage("")
			ChatFrame1:AddMessage("'/bcb channel onoff' sets named channel on or off")
			ChatFrame1:AddMessage("               valid onoffs are: 0 (off), 1 (on), 2 (on for external)")
			
			ChatFrame1:AddMessage("")
			ChatFrame1:AddMessage("'/bcb channel onoff sound' sets channel on or off and defines sound to use")
			ChatFrame1:AddMessage("               use onoff '1' for internal sound name Eg. 'TellMessage'")
			ChatFrame1:AddMessage("               use onoff '2' for external sound file Eg. 'Guild-Yo.ogg'")
			ChatFrame1:AddMessage("               (folder 'Interface/AddOns/Brigand_Chatterbox/' will be pre-pended")
		else
			ChatFrame1:AddMessage("Brigand_Chatterbox report one:")
			for i = 1, #_G.ChatChannel do
				if( _G.ChatChannel[i]:upper() == channel ) then --compare upper cases
					ChatFrame1:AddMessage( _G.ChatChannel[i] .. " " .. _G.ChatState[_G.ChatChannel[i]] .. " " .. _G.ChatSound[_G.ChatChannel[i]] )
					break --out of for
				end
			end
		end -- help
	else
		if (onoff ~= "1" and onoff ~= "2") then --only "0" (off) or "1" (internal) or "2" (external)
			onoff = "0"
		end
	end --reportone
	
	--set one channel
	local setsound = true
	if (sound == nil) then
		setsound = false
	elseif (sound:len() == 0) then
		setsound = false
	end
	
	local setchannel = not (reportall or reportone)
	if (setchannel) then
		local index
		for i = 1, #_G.ChatChannel do
			if( _G.ChatChannel[i]:upper() == channel ) then --compare upper cases
				index = i
				_G.ChatState[_G.ChatChannel[index]] = onoff
				
				if (setsound) then
					_G.ChatSound[_G.ChatChannel[index]] = sound
				end
				break --out of for
			end
		end

		--concatenate result string
		local result = "'" .. _G.ChatChannel[index] .. "' to"
		if (onoff == "0") then
			result = result .. " 'off'"
		elseif (onoff == "1") then
			result = result .. " 'internal'"
		else
			result = result .. " 'external'"
		end

		result = result .. " sound '" .. _G.ChatSound[_G.ChatChannel[index]] .. "'"

		ChatFrame1:AddMessage("Brigand_Chatterbox set:" .. result )
	end --setchannel
end
	

--this is the frame that actually does the work
function Brigand_Chatterbox_OnLoad(frame)
	if (bVerbose) then
		ChatFrame1:AddMessage("Brigand_Chatterbox:OnLoad")
	end
	
	frame:RegisterEvent( "CHAT_MSG_GUILD" )
	
	frame:RegisterEvent( "CHAT_MSG_PARTY" )
	frame:RegisterEvent( "CHAT_MSG_RAID" )
	
	frame:RegisterEvent( "CHAT_MSG_WHISPER" )
--	frame:RegisterEvent( "CHAT_MSG_WHISPER_INFORM" )
	
	frame:RegisterEvent( "CHAT_MSG_EMOTE" )
	frame:RegisterEvent( "CHAT_MSG_TEXT_EMOTE" )

	frame:RegisterEvent( "CHAT_MSG_BN_CONVERSATION" )
	frame:RegisterEvent( "CHAT_MSG_BN_WHISPER" )

	frame:RegisterEvent( "CHAT_MSG_SAY" )
	
	frame:RegisterEvent( "CHAT_MSG_YELL" )
	
	--I/O is disabled in WoW LUA so use SavedVariables on load/exit
	frame:RegisterEvent( "ADDON_LOADED" )
end

function Brigand_Chatterbox_OnEvent( self, event, ... )
	if (bVerbose) then
		ChatFrame1:AddMessage("Brigand_Chatterbox:OnEvent" .. event)
	end
	
	if (not bLoaded) then
		if (event == "ADDON_LOADED") then
			addon = ...
			if (addon == "Brigand_Chatterbox") then
				bLoaded = true
				--if (bVerbose) then
					ChatFrame1:AddMessage("Brigand_Chatterbox:Loaded")
					--SendChatMessage( "May the stars guide you", "GUILD", nil, nil )
				--end
				
				--now that saved vars are loaded, "upgrade" to new defaults if not included
				for i = 1, #_G.DefaultChannel do
					--indexed by number
					if (_G.ChatChannel[i] == nil) then
						_G.ChatChannel[i] = _G.DefaultChannel[i]
					end
					
					--indexed by name
					if (_G.ChatSound[_G.DefaultChannel[i]] == nil) then
						_G.ChatSound[_G.DefaultChannel[i]] = _G.DefaultSound[_G.DefaultChannel[i]]
					end
					
					if (_G.ChatState[_G.DefaultChannel[i]] == nil) then
						_G.ChatState[_G.DefaultChannel[i]] = _G.DefaultState[_G.DefaultChannel[i]]
					end
				end
				
				-- optional registration with the "Portfoilio" library for "Options panel"
				PortfolioLib = LibStub and LibStub("Portfolio")
				Brigand_Chatterbox_RegisterOptionsTable()
			end
		end
	else
		local SoundFilePrefix = "Interface\\AddOns\\Brigand_Chatterbox\\"
		
		if ( (event == "CHAT_MSG_GUILD") and (_G.ChatState.Guild ~= "0") ) then
			if (_G.ChatState.Guild == "1") then --internal sound
				PlaySound( _G.ChatSound.Guild )
			else --"2" means external sound
				PlaySoundFile( SoundFilePrefix .. _G.ChatSound.Guild )
			end
		elseif ( ((event == "CHAT_MSG_PARTY") or (event == "CHAT_MSG_RAID")) and (_G.ChatState.Party ~= "0") ) then
			if (_G.ChatState.Party == "1") then --internal sound
				PlaySound( _G.ChatSound.Party )
			else --"2" means external sound
				PlaySoundFile( SoundFilePrefix .. _G.ChatSound.Party )
			end
		elseif ( ((event == "CHAT_MSG_WHISPER") or (event == "CHAT_MSG_WHISPER_INFORM")) and (_G.ChatState.Whisper ~= "0") ) then
			if (_G.ChatState.Whisper == "1") then --internal sound
				PlaySound( _G.ChatSound.Whisper )
			else --"2" means external sound
				PlaySoundFile( SoundFilePrefix .. _G.ChatSound.Whisper )
			end
		elseif ( ((event == "CHAT_MSG_EMOTE") or (event == "CHAT_MSG_TEXT_EMOTE")) and (_G.ChatState.Emote ~= "0") ) then
			if (_G.ChatState.Emote == "1") then --internal sound
				PlaySound( _G.ChatSound.Emote )
			else --"2" means external sound
				PlaySoundFile( SoundFilePrefix .. _G.ChatSound.Emote )
			end
		elseif ( ((event == "CHAT_MSG_BN_CONVERSATION") or (event == "CHAT_MSG_BN_WHISPER")) and (_G.ChatState.RealID ~= "0") ) then
			if (_G.ChatState.RealID == "1") then --internal sound
				PlaySound( _G.ChatSound.RealID )
			else --"2" means external sound
				PlaySoundFile( SoundFilePrefix .. _G.ChatSound.RealID )
			end
		elseif ( ((event == "CHAT_MSG_SAY") and (_G.ChatState.Say ~= "0")) or ((event == "CHAT_MSG_YELL") and (_G.ChatState.Yell ~= "0")) ) then --filter "says" and "yells" for "friends"
			local text, sender = ... --same format for both "say" and "yell"
			local num = GetNumFriends()
			local friendName
			for i = 1, num do
				friendName = GetFriendInfo( i )
				if (sender == friendName ) then
					if (event == "CHAT_MSG_SAY") then
						if (_G.ChatState.Say == "1") then --internal sound
							PlaySound( _G.ChatSound.Say )
						else --"2" means external sound
							PlaySoundFile( SoundFilePrefix .. _G.ChatSound.Say )
						end
						break --out of for
					elseif (event == "CHAT_MSG_YELL") then
						if (_G.ChatState.Yell == "1") then --internal sound
							PlaySound( _G.ChatSound.Yell )
						else --"2" means external sound
							PlaySoundFile( SoundFilePrefix .. _G.ChatSound.Yell )
						end
						break --out of for
					end
				end
			end
		end
	end
end

function Brigand_Chatterbox_RegisterOptionsTable()
	if not PortfolioLib then return end

	--auto-construct table of options
	local Brigand_Chatterbox_OptionsTable =
	{
		id="Brigand_Chatterbox";
		text="Brigand Chatterbox";
		addon="Brigand_Chatterbox";
		about=false;
		options = {};
	}
	
	local lastAnchor = nil;
	local nOptions = 6;
	for i = 1, #_G.ChatChannel do
		--header
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+1] = {};
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+1].id = "SectionHeader_" .. _G.ChatChannel[i];
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+1].text = _G.ChatChannel[i];
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+1].type = CONTROLTYPE_HEADER;
		if( lastAnchor ~= nil ) then
			Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+1].point = {nil, lastAnchor, nil, nil, nil};
		end
		
		--checkboxes
		
		--off
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+2] = {};
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+2].id = _G.ChatChannel[i] .. "_Off";
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+2].text = "None";
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+2].tooltipText = "Do not play a sound";
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+2].type = CONTROLTYPE_CHECKBOX;
		if( _G.ChatState[_G.ChatChannel[i]] == "0" ) then
			Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+2].defaultValue = "1";
		else
			Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+2].defaultValue = "0";
		end
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+2].callback = function(...) Brigand_Chatterbox_RadioCB(_G.ChatChannel[i], "Off", ...) end;
		
		--internal
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+3] = {};
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+3].id = _G.ChatChannel[i] .. "_Internal";
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+3].text = "Internal";
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+3].tooltipText = "Type the name of an internal sound like:\nTellMessage\nFriendJoinGame\nigPlayerInvite\ngsTitleQuit\nMINIMAPOPEN";
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+3].type = CONTROLTYPE_CHECKBOX;
		if( _G.ChatState[_G.ChatChannel[i]] == "1" ) then
			Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+3].defaultValue = "1";
		else
			Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+3].defaultValue = "0";
		end
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+3].callback = function(...) Brigand_Chatterbox_RadioCB(_G.ChatChannel[i], "Internal", ...) end;
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+3].point = {"LEFT", Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+2].id, "RIGHT", 100, 0};
		
		--external
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+4] = {};
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+4].id = _G.ChatChannel[i] .. "_External";
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+4].text = "External";
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+4].tooltipText = "Type the filename of an external sound in the Chatterbox folder";
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+4].type = CONTROLTYPE_CHECKBOX;
		if( _G.ChatState[_G.ChatChannel[i]] == "2" ) then
			Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+4].defaultValue = "1";
		else
			Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+4].defaultValue = "0";
		end
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+4].callback = function(...) Brigand_Chatterbox_RadioCB(_G.ChatChannel[i], "External", ...) end;
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+4].point = {"LEFT", Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+3].id, "RIGHT", 100, 0};
		
		--sound
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+5] = {};
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+5].id = _G.ChatChannel[i] .. "_Sound";
		lastAnchor = Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+5].id; --for next section
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+5].type = CONTROLTYPE_EDITBOX;
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+5].width = 200;
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+5].defaultValue = _G.ChatSound[_G.ChatChannel[i]];
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+5].callback = function(...) Brigand_Chatterbox_SoundCB(_G.ChatChannel[i], ...) end;
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+5].point = {nil, Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+2].id, nil, nil, nil};

		--test
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+6] = {};
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+6].id = _G.ChatChannel[i] .. "_Test";
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+6].text = "Test";
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+6].type = CONTROLTYPE_BUTTON;
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+6].callback = function(...) Brigand_Chatterbox_TestCB(_G.ChatChannel[i], ...) end;
		Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+6].point = {"LEFT", Brigand_Chatterbox_OptionsTable.options[(i-1)*nOptions+5].id, "RIGHT", 25, 0};
	end

	optionsFrameID = PortfolioLib.RegisterOptionSet(Brigand_Chatterbox_OptionsTable);
end

function Brigand_Chatterbox_RadioCB(group, id, value, isGUI, isUpdate) 
	if( bVerbose ) then 
		PortfolioLib.Print(group .. " " .. id .. " callback( \""..tostring(value).."\", "..tostring(isGUI)..", "..tostring(isUpdate)..")");
	end
	
	--radiobutton-like behavior
	local control;
	if( value == "0" and isGUI ) then
		control = PortfolioLib.GetControl( optionsFrameID, group .. "_" .. id );
		control.SetValue( control, "1" ); --cannot "turn off"
	end
	
	if( value == "1" ) then
		if( id == "Off" ) then
			control = PortfolioLib.GetControl( optionsFrameID, group .. "_Internal" )
			control.SetValue(control,"0",false,false);
			control = PortfolioLib.GetControl( optionsFrameID, group .. "_External" )
			control.SetValue(control,"0",false,false);
			
			_G.ChatState[group] = "0"; --off
			local test = PortfolioLib.GetControl( optionsFrameID, group .. "_Test" );
			test.Disable( test );

		elseif( id == "Internal" ) then
			control = PortfolioLib.GetControl( optionsFrameID, group .. "_Off" )
			control.SetValue(control,0);
			control = PortfolioLib.GetControl( optionsFrameID, group .. "_External" )
			control.SetValue(control,0);
			
			_G.ChatState[group] = "1"; --internal
			local test = PortfolioLib.GetControl( optionsFrameID, group .. "_Test" );
			test.Enable( test );
			
		elseif( id == "External" ) then
			control = PortfolioLib.GetControl( optionsFrameID, group .. "_Off" )
			control.SetValue(control,"0",false,false);
			control = PortfolioLib.GetControl( optionsFrameID, group .. "_Internal" )
			control.SetValue(control,"0",false,false);
						
			_G.ChatState[group] = "2"; --external
			local test = PortfolioLib.GetControl( optionsFrameID, group .. "_Test" );
			test.Enable( test );
		end
	end
end

function Brigand_Chatterbox_SoundCB(group, value, isGUI, isUpdate) 
	if (bVerbose) then 
		PortfolioLib.Print(group.." callback( \""..tostring(value).."\", "..tostring(isGUI)..", "..tostring(isUpdate)..")");
	end
	
	local sound = PortfolioLib.GetControl( optionsFrameID, group .. "_Sound" );
	_G.ChatSound[group] = sound.GetText( sound );
end

function Brigand_Chatterbox_TestCB(group, value, isGUI, isUpdate) 
	if (bVerbose) then 
		PortfolioLib.Print(group.." callback( \""..tostring(value).."\", "..tostring(isGUI)..", "..tostring(isUpdate)..")");
	end
	
	if (_G.ChatState[group] == "1") then --internal sound
		PlaySound( _G.ChatSound[group] )
	else --"2" means external sound
		PlaySoundFile( "Interface\\AddOns\\Brigand_Chatterbox\\" .. _G.ChatSound[group] )
	end
end
